
#include "usart1.h"

#define  USART1_RXNE  1
#define  USART1_IDLE  0
#define  USART1_INT   USART1_RXNE

uint8_t  Touch_tx_buffer[1024];   /* ڷͻ */
uint8_t  Touch_rx_buffer[1024];   /* ڽܻ */
uint16_t Touch_tx_flag = 0;       /* һ֡ݱ־¼ݸ */

void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/********************************************************************************************************
** : USART1_Init,  1ʼ
********************************************************************************************************/
void USART1_Init(uint32_t bound)
{
    GPIO_InitTypeDef   GPIO_InitStructure={0};
    USART_InitTypeDef  USART_InitStructure={0};
    NVIC_InitTypeDef   NVIC_InitStructure={0};

    /* GPIOUSARTʱ */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

    /* GPIOģʽIO */
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_9;              // PA9(TX)
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;    // IOƵ
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;        // 
    GPIO_Init(GPIOA,&GPIO_InitStructure);                  // ʼ
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_10;               // PA10(RX)
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;// 
    GPIO_Init(GPIOA,&GPIO_InitStructure);                  // ʼ

    /* ôӲ */
    USART_InitStructure.USART_BaudRate = bound;    /*  */
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    USART_Init(USART1, &USART_InitStructure);

    USART_ITConfig(USART1, USART_IT_IDLE, ENABLE);    /* ʹܴڿж */
    USART_ClearFlag(USART1, USART_FLAG_TC | USART_FLAG_IDLE);
    USART_Cmd(USART1, ENABLE);        /* ʹܴ */
    /* շDMA */
    USART_DMACmd(USART1,USART_DMAReq_Tx | USART_DMAReq_Rx,ENABLE);

    /* ʹܴ1ж */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{
    USART_SendData(pUSARTx, data);
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

void USARTx_SendStr(USART_TypeDef* pUSARTx, char *str)
{
    uint8_t i = 0;
    do
    {
       USARTx_SendByte(pUSARTx, *(str+i));
       i++;
    }while(*(str+i) != '\0');
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TC) == RESET);
}

/********************************************************************************************************
** : USART1_DMA_Init,  1ʼ ô1DMADMAжϡ
********************************************************************************************************/
void USART1_DMA_Init(void)
{
    DMA_InitTypeDef DMA_InitStructure;

    /* DMAͨʱ */
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE);

    DMA_DeInit(DMA1_Channel4);//TX ͨ
    DMA_DeInit(DMA1_Channel5);//RX ͨ

    /* TX ͨ */
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)(&USART1->DATAR);
    DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)Touch_tx_buffer;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
    DMA_InitStructure.DMA_BufferSize = 0;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMA1_Channel4,&DMA_InitStructure);

    /* RX ͨ */
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)(&USART1->DATAR);
    DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)Touch_rx_buffer;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_InitStructure.DMA_BufferSize = 1024;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMA1_Channel5,&DMA_InitStructure);

    /* ʹDMAշͨ */
    DMA_Cmd(DMA1_Channel4,ENABLE);
    DMA_Cmd(DMA1_Channel5,ENABLE);

    /* ûʹDMAɻ߷жϣҪ */
}

/********************************************************************************************************
** : USART1_IRQHandler,  1жϷ
********************************************************************************************************/
void USART1_IRQHandler(void)
{
    uint16_t Count = 0;

    /* տж  */
    if (USART_GetITStatus(USART1, USART_IT_IDLE) != RESET)
    {
        /* ־ȶSRٶDR */
        USART1->STATR;
        USART1->DATAR;

        /* ȡݸ */
        Count = DMA_GetCurrDataCounter(DMA1_Channel5);
        Touch_tx_flag = 1024 - Count;

        /* ݣʾյʹDMAͳȥ */
        memcpy((uint8_t *)Touch_tx_buffer,(uint8_t *)Touch_rx_buffer,Touch_tx_flag);

        /* DMAոλ */
        DMA_Cmd(DMA1_Channel5,DISABLE);
        DMA_SetCurrDataCounter(DMA1_Channel5,1024);
        DMA_Cmd(DMA1_Channel5,ENABLE);
    }
}

